%{
/*  atenea
 *  Copyright (C) 1999 <ryu@mundivia.es>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#include "rules.h"
#include <glib.h>
void yyerror(char *str,...);
extern int yyline;
extern GList *rules;
extern GList *default_say;

%}

%union {
  char *s_value;
  GList *l_value;
  Rule  *r_value;
};

%token <s_value> STRING

%token PLUS BAR ARROW ASTERISC DEFAULT

%type <l_value> rules
%type <r_value> rule
%type <l_value> conditions
%type <l_value> strlist
%type <l_value> strop

%start general

%%
general: rules DEFAULT default_rules {}
	;
rules:	  rule		{ rules=g_list_append(NULL,$1); }
	| rules rule { rules=g_list_append(rules,$2);   }
	;
default_rules: strop { default_say=$1; }
	;

rule:	  conditions ARROW strop			{ $$=rule_new($1,$3,NULL); }
	| conditions ARROW strop ASTERISC strlist	{ $$=rule_new($1, $3, $5); }
	;

conditions:
	  strlist		    { $$=g_list_append(NULL,$1); }
	| strlist BAR conditions { $$=g_list_append($3,$1);   }
	;

strlist:
	  STRING		{ $$=g_list_append(NULL,$1); }
	| STRING PLUS strlist	{ $$=g_list_append($3,$1);   }
	;
strop:
	  STRING		{ $$=g_list_append(NULL,$1); }
	| STRING BAR strop	{ $$=g_list_append($3,$1);   }
	;
%%

void yyerror(char *str,...)
{
  printf("There was an error near line %i !!!\n",yyline);
}
